package jawful;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.io.File;
import java.io.IOException;

import org.junit.Test;


public class CommandConverterTest {
	@Test
	//TODO
	public void testConvert() throws IOException {
		CommandConverter converter = new CommandConverter();
		
		String[] command = new String[] { 
		"/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/javacics",
		"-Dzero.test=",
	    "-Demma.coverage.out.file=/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/tests/fvt/zero.messaging.broker.tests/export/junit/zero.messaging.broker.tests/coverage/coverage.emma",
	    "-Demma.coverage.out.merge=true",
	    "-Djava.library.path=",
	    "-Dzerohome=/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero",
	    "-classpath",
	    "/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/tests/fvt/zero.messaging.broker.tests/classes:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.cics.core-1.0.0.0.2905/lib/zero.cics.core.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.cics.core-1.0.0.0.2905/lib/dfjcics.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.core.webtools-1.1.1.2.30784/lib/zero.core.webtools.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/zero.messaging.broker.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/com.ibm.micro.bridge.jndi.jms_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/com.ibm.micro.bridge.mq.jms_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/com.ibm.micro.gettingstarted_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/com.ibm.micro.nl_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/com.ibm.micro_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/objectManager.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/sib.matchspace.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/sib.matchspace.jvmUtils.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.broker-1.1.1.2.29797/lib/sib.matchspaceImpl.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/zero.messaging.connection.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.micro.utils.nl_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.micro.utils_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.mqttclient.jms.nl_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.mqttclient.jms_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.mqttclient.nl_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.mqttclient_2.1.0.2-20081128.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.msg.client.commonservices.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.msg.client.jms.internal.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/com.ibm.msg.client.provider.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.messaging.connection-1.1.1.2.29860/lib/geronimo-jms_1.1_spec-1.0.1.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.connection.jms-1.1.1.2.30311/lib/zero.connection.jms.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.timer-1.1.1.2.30789/lib/zero.timer.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.core-1.1.1.2.30804/lib/zero.core.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.core-1.1.1.2.30804/lib/asm-2.2.3.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.core-1.1.1.2.30804/lib/groovy-1.6.2.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.management.spi-1.1.1.2.29370/lib/zero.management.spi.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.management.spi-1.1.1.2.29370/lib/selectorProviderSPI.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.cli.tasks-1.1.1.2.30808/lib/zero.cli.tasks.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.cli.tasks-1.1.1.2.30808/lib/ivy-2.0.0.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.management.native.process-1.1.1.2.29725/lib/zero.management.native.process.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.network-1.1.1.2.30705/lib/zero.network.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.network.support-1.1.1.2.30132/lib/zero.network.support.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.kernel-1.1.1.2.30782/lib/zero.kernel.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/test/zero/zero-repository/stable/expanded/zero/zero.kernel-1.1.1.2.30782/lib/antlr-2.7.7.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/sMash/BUILD/zero.build/prereqs/ant-deps/emma-2.0.5312.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/sMash/BUILD/zero.build/prereqs/ant-deps/emma_ant-2.0.5312.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/sMash/BUILD/zero.build/prereqs/ant-deps/junit-4.3.1.jar:/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/sMash/BUILD/zero.build/export/zero.build.jar:/MV26/p8build/hudson/tools/zos/apache-ant-1.7.1/lib/junit-3.8.2.jar:/MV26/p8build/hudson/tools/zos/apache-ant-1.7.1/lib/ant-launcher.jar:/MV26/p8build/hudson/tools/zos/apache-ant-1.7.1/lib/ant.jar:/MV26/p8build/hudson/tools/zos/apache-ant-1.7.1/lib/ant-junit.jar",
	    "org.apache.tools.ant.taskdefs.optional.junit.JUnitTestRunner",
	    "zero.messaging.broker.BrokerTest",
	    "filtertrace=true",
	    "haltOnError=false",
	    "haltOnFailure=false",
	    "formatter=org.apache.tools.ant.taskdefs.optional.junit.SummaryJUnitResultFormatter",
	    "showoutput=true",
	    "outputtoformatters=true",
	    "logtestlistenerevents=true",
	    "formatter=org.apache.tools.ant.taskdefs.optional.junit.XMLJUnitResultFormatter,/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/tests/fvt/zero.messaging.broker.tests/export/junit/zero.messaging.broker.tests/results/TEST-zero.messaging.broker.BrokerTest.xml",
	    "crashfile=/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/tests/fvt/zero.messaging.broker.tests/junitvmwatcher6667945361712525367.properties",
	    "propsfile=/MV26/p8build/hudson/working_dir/workspace/sMash4CICS_FVT/trunk/tests/fvt/zero.messaging.broker.tests/junit7885447450441459174.properties"
		};

		try {
			File f = new File("jawful.jar");
			f.createNewFile();
			System.setProperty("jawful.jar.path", f.getAbsolutePath());
			
			String[] newCommand = converter.convert(command);
			for (int i=0; i<newCommand.length; i++) {
				System.out.println(i + ": " + newCommand[i]);
			}
			
			assertEquals("Should have added 2 elements to command", command.length + 2, newCommand.length);
			assertEquals("CP of new command should be jawful.jar", f.getAbsolutePath(), newCommand[7]);
			assertTrue("New command CP should be shorter than original command CP", newCommand[7].length() < command[7].length());
			assertEquals("New command's class to launch should be jawful.Wrapper", "jawful.Wrapper", newCommand[8]);
			assertTrue("New command's first app arg should be the classpath file", newCommand[9].contains("jawful.classpath."));
			
			//TODO: test that contents of file named newCommand[9] is same as command[7] (original classpath)
			
		} finally {
			new File("jawful.jar").delete();
			System.setProperty("jawful.jar.path", "");
		}
		
		
	}
}
