package jawful;

import java.net.URL;
import java.net.URLClassLoader;

import org.junit.Test;

/**
 * This test is launched as part of JUnitModifierTest. 
 */
public class DummyTest {
	@Test
	public void dummyTest() {
		
		System.out.println("----> Hello!");
				
		try {
			throw new Exception("check call stack");
		} catch (Exception e) {
			StackTraceElement[] fst = e.getStackTrace();
			StackTraceElement ste = fst[fst.length-1];
			System.out.println("----> Top callstack element is: " + ste.getClassName() + "." + ste.getMethodName() + "()");
			System.out.println("----> Call stack is...");
			e.printStackTrace(System.out);
		}

		System.out.println("----> Classpath is...");
		URL[] urls = ((URLClassLoader)ClassLoader.getSystemClassLoader()).getURLs();
		for (URL url : urls) {
			System.out.println(url);
		}
		System.out.println("----> Total elements: " + urls.length);
		System.out.println("----> Goodbye!");
	}
}
